
source("main.R")
source("goodness.R")

set.seed(1)
####################### real data analysis on DMD  #################################

data = read.csv("real_data.csv", header = T)

H= data$H
status =data$Status
X_0 = H[status==0] #status = 0 healthy
X_1 = H[status==1] # status= 1 diseased
# PK= data$PK
# status =data$Status
# X_0 = PK[status==0] #status = 0 healthy
# X_1 = PK[status==1] # status= 1 diseased

########################### goodness of fit test for q(x)###################

boot_ks(X_0,X_1,qx=1) # qx=1: q(x)= log(x); qx=2: q(x)= x

########################### joint confidence region for (AUC,J)#############
set.seed(1)
result<-BEL(X_0,X_1,0.95)
result
########################### draw confidence region for biomarker H ###################
para<-c(result$estimated_J,result$estimated_AUC)
n<-length(c(X_0,X_1))
hat_Sig<-result$hat_Sigma/n
qnchi<-result$bootstrap_critical_value

confidence.ellipsoid=function(mu, S,Cri.Value,e.lty=1,e.col=1,e.lwd=1,e.fill=NA){
  library(plotrix)
  S.inv=solve(S)
  Sigma1 = S.inv/Cri.Value
  draw.ellipse(x=mu[1],y=mu[2],
               a=1/sqrt(eigen(Sigma1)$values[1]),
               b=1/sqrt(eigen(Sigma1)$values[2]),
               angle = atan(eigen(Sigma1)$vectors[2,1]/eigen(Sigma1)$vectors[1,1]),
               deg=FALSE,nv=500,lty=e.lty,border=e.col,lwd=e.lwd,col=e.fill)
}

new_hat_sig<-matrix(c(hat_Sig[2,2],hat_Sig[2,1],hat_Sig[1,2],hat_Sig[1,1]),ncol=2)
par(mfrow=c(1,1))
plot(c(0,0),type="n",ylim = c(0.2,0.6),xlim=c(0.6,0.9),ylab="Youden index",xlab="AUC")
confidence.ellipsoid(c(para[2],para[1]),new_hat_sig,qnchi,e.lty=1,e.col=1,e.lwd=1,e.fill=NA)
legend("bottomright",                                   
       legend=c("BEL"),       
       col=c(1),               
       lty=c(1),lwd=c(1),cex=0.7)

points(para[2],para[1],'o',cex=0.6)

text(para[2]+0.04,para[1]-0.03,expression("o (0.753,0.371)"), pos=3, cex=0.7)


########################### Hypothesis test ###################
set.seed(1)
data = read.csv("real_data.csv", header = T)
PK= data$PK
status =data$Status
X_0 = PK[status==0] #status = 0 healthy
X_1 = PK[status==1] # status= 1 diseased
AUC_0 <- 0.753
J_0 <- 0.371
BELT(X_0,X_1,AUC_0,J_0) # H_0: AUC <= AUC_0 or J<=J_0
