ks_test = function(x,y,qx){
  # the size of sample from f_0
  n0=length(x)
  # the size of sample from f_1
  n1=length(y)
  nn=c(n0,n1)
  n = sum(nn)
  rho=nn/sum(nn)
  
  group=c(rep(0,length(x)),rep(1,length(y)))
  td1=c(x,y) # combined samples;
  td2 = log(td1)
  td3 = td2*td2
  td4 = td1*td1
  x1=sort(td1)  # sorted samples
  x2=log(x1)
  if(qx==1){ result <- glm(group~td2, family = binomial(link = "logit")); Xmat <- cbind(1,x2) }  # q(x)=log(x)
  if(qx==2){ result <- glm(group~td1, family = binomial(link = "logit")); Xmat <- cbind(1,x1) }  # q(x)= x

  outcoef=coef(result)
  outcoef[1]=outcoef[1]-log(rho[2]/rho[1])
  P0 = 1/(n0+n1*exp(Xmat%*%outcoef))
  P1 = P0*exp(Xmat%*%outcoef)
  
  phat <- cbind(x1, P0, P1)
  KS_stat <- NULL
  for(i in 1:2){
    Gihat <- function(t){ sum(phat[,i+1]*ifelse(x1 <= t,1,0)) }
    Gi_edf <- function(t){ sum(ifelse(td1[group==(i-1)] <= t,1,0))/nn[i] }
    Deltai <- function(x){ sqrt(n)*abs(Gihat(x) - Gi_edf(x)) }
    Deltai_res <- apply(as.matrix(x1), 1, Deltai)
    KS_stat <- c(KS_stat, max(Deltai_res))
  }
  
  Delta_stat <- mean(rho*KS_stat)
  
  return(list(KS_test=Delta_stat, phat=phat, coefficients=outcoef, sizes=nn))
}


boot_ks <- function(x,y,qx,B=1000){
  test <- ks_test(x,y,qx)
  obs_stat <- test$KS_test
  phat <- test$phat
  n <- test$size  
  boot_sample <- NULL 
  for(j in 1:2){
    sample_i <- matrix(sample(phat[,1], B*n[j], replace=T, prob=phat[,j+1]), nrow=n[j], ncol=B)
    boot_sample <- rbind(boot_sample, sample_i)
  }
  
  test <- function(sam){
    x = sam[1:n[1]]
    y = sam[-(1:n[1])]
    as.numeric(ks_test(x,y,qx)$KS_test)
  }
  
  R_boot <- apply(boot_sample, 2, test)
  pvalue <- mean(na.omit(R_boot) > obs_stat)
  list(pval = pvalue, obs_val = obs_stat )  
}

