sub_bel<-function(x1,x2,ta,log_trans){
  
  nx <- c(x1,x2)
  n_0<-length(x1)
  n_1<-length(x2)
  n<-n_0+n_1
  rho<-n_1/n
  if(log_trans==T){
    qx<-log(c(x1,x2))
  }
  else{qx<-c(x1,x2)}
  nFunc_theta<-function(theta)
  {
    
    A <- theta[1]+theta[2]*qx
    mz<-apply(cbind(rep(0,n),A),1,max)
    A_m<-A-mz
    B<-(1-rho)*exp(-mz)+rho*exp(A_m)
    l_1<- -sum( log(B)+mz)
    l_2 <- sum(A[(n_0+1):n])
    l<- -l_1-l_2
  }
  old_theta<-c(0.5,0.5)
  nre <- optim(old_theta,nFunc_theta,method="L-BFGS-B")
  nhat_theta<-nre$par
  if(log_trans==T){
    nhat_c<-exp(-nre$par[1]/nre$par[2])}
  else{
    nhat_c<--nre$par[1]/nre$par[2]}
  
  ## estimation of J ##
  nF_0_2<-1/n*1/(1-rho+rho*exp(nhat_theta[1]+nhat_theta[2]*qx))
  nF_1_2<-1/n*1/((1-rho)*exp(-nhat_theta[1]-nhat_theta[2]*qx)+rho)
  
  # F_0_2<-1/n*1/(1-rho+rho*exp(hat_theta[1]+hat_theta[2]*X))
  # F_1_2<-1/n*1/((1-rho)*exp(-hat_theta[1]-hat_theta[2]*X)+rho)
  ncumula<-function(x){
    index_x<-which(x>=nx)
    index_x
  }
  
  
  
  ncumul_F0<-rep(0,n)
  for(i in 1:n){
    ncumul_F0[i]<- sum(nF_0_2[ncumula(nx[i])])
  }
  
  ncumul_F1<-rep(0,n)
  for(i in 1:n){
    ncumul_F1[i]<- sum(nF_1_2[ncumula(nx[i])])
  }
  
  ncu_F_0<-function(x){
    le<-length(x)
    cu_F0<-rep(0,le)
    for(i in 1:le){
      cu_F0[i]<- sum(nF_0_2[ncumula(x[i])])
    }
    cu_F0
  }
  
  ncu_F_1<-function(x){
    le<-length(x)
    cu_F1<-rep(0,le)
    for(i in 1:le){
      cu_F1[i]<- sum(nF_1_2[ncumula(x[i])])
    }
    cu_F1
  }
  
  
  nes_J<-function(x){
    sum(nF_0_2[ncumula(x)])-sum(nF_1_2[ncumula(x)])
  }
  
  #nes_hat_J<-nes_J(nhat_c); nhat_c_fina<-nhat_c
  
  if(nhat_c>=min(nx) && nhat_c<=max(nx) && nes_J( nhat_c)>=0 && nes_J(nhat_c)<=1 ){
    nes_hat_J<-nes_J(nhat_c); nhat_c_fina<-nhat_c
  }else{
    nesJ<-rep(0,n)
    nesJ<-ncumul_F0-ncumul_F1
    nes_hat_J<-max(nesJ)   ; nhat_c_fina<-nx[which.max(nesJ)]
  }
  ## estimation of AUC ##
  
  
  nA_2<-sum((1-ncumul_F1)*nF_0_2)
  nes_AUC<-nA_2/2+sum(ncumul_F0*nF_1_2)/2
  
  ## covariance estimation of (J, AUC) ##
  
  S<-rho/(1-rho)*exp(nhat_theta[1]+nhat_theta[2]*qx)
  Q<-cbind(rep(1,n),qx)
  C<-matrix(rep(0,2*n),ncol=2)
  D<-matrix(rep(0,2*n),ncol=2)
  M<-matrix(rep(0,2*2),ncol=2)
  
  sig_00<-sum(nF_0_2*(1-(1-rho)/rho*S)^2/(S+1)*(nx<=nhat_c_fina))
  sig_01<-sum(nF_0_2*(1-(1-rho)/rho*S)*((1-rho)/rho*ncumul_F0*S+1-ncumul_F1)/(S+1)*(nx<=nhat_c_fina))
  sig_11<-sum(nF_0_2*((1-rho)/rho*ncumul_F0*S+1-ncumul_F1)^2/(S+1))
  C<-nF_0_2*(((1-rho)/rho*ncumul_F0-1+ncumul_F1)*S/(S+1))*Q
  D<-nF_0_2*((nx<=nhat_c_fina)*S/(S+1))*Q
  M<-t(Q)%*%((nF_0_2*(1-rho)*S/(S+1))*Q)
  
  hat_C<-apply(C,2,sum)
  hat_D<-apply(D,2,sum)
  hat_M<-solve(M)
  
  
  nSigma_00<- -1/(1-rho)*(ncu_F_0(nhat_c_fina))^2-1/rho*(ncu_F_1(nhat_c_fina))^2+1/(1-rho)*sig_00+1/(rho^2)*hat_D%*%hat_M%*%hat_D
  nSigma_01 <- -1/rho*hat_D%*%hat_M%*%hat_C-1/(1-rho)*ncu_F_0(nhat_c_fina)*(nA_2)+1/rho*(2*nes_AUC-(nA_2))*ncu_F_1(nhat_c_fina)+1/(1-rho)*sig_01
  nSigma_11 <- hat_C%*%hat_M%*%hat_C-1/(1-rho)*(nA_2)^2-1/rho*(2*nes_AUC-nA_2)^2+1/(1-rho)*sig_11
  
  hat_sigma<-matrix(c( nSigma_00/n,nSigma_01/n,nSigma_01/n,nSigma_11/n),ncol=2)
  solve_hat_sigma<-matrix(c(nSigma_11/n,-nSigma_01/n,-nSigma_01/n,nSigma_00/n),ncol=2)
  req<-list()
  
  if(nes_hat_J<=10^(-5)){
    req[[1]]<-c(-2,nes_AUC,0)
    req[[2]]<-nF_0_2
    req[[3]]<-nF_1_2
    req[[4]]<- 0
  }else{
    
    req[[1]]<-c(nes_hat_J,nes_AUC,(c(nes_hat_J,nes_AUC)-ta)%*%(solve_hat_sigma/det(hat_sigma))%*%(c(nes_hat_J,nes_AUC)-ta))
    req[[2]]<-nF_0_2
    req[[3]]<-nF_1_2
    req[[4]]<- hat_sigma
  }
  return(req)
  
}

find_beta_auc<-function(x0,x1,cbeta,eta,log_trans){
  nx<-c(x0,x1)
  n<-length(nx)
  n_0<-length(x0)
  n_1<-length(x1)
  rho<-length(x1)/n
  
  if(log_trans==T){
    qx<-log(c(x0,x1))
  }
  else{qx<-c(x0,x1)}
  
  find_beta2<-function(t){
    
    nalpha<-function(theta)
    {
      
      A <- theta+t*qx
      mz<-apply(cbind(rep(0,n),A),1,max)
      A_m<-A-mz
      B<-(1-rho)*exp(-mz)+rho*exp(A_m)
      l_1<- -sum( log(B)+mz)
      l_2 <- sum(A[(n_0+1):n])
      l<- -l_1-l_2
    }
    nre <- optim(0.5,nalpha,method="L-BFGS-B")
    h_alpha<-nre$par
    
    
    nF_0_2<-1/n*1/(1-rho+rho*exp(h_alpha+t*qx))
    nF_1_2<-1/n*1/((1-rho)*exp(-h_alpha-t*qx)+rho)
    
    ncumula<-function(x){
      index_x<-which(x>=nx)
      index_x
    }
    
    ncumul_F0<-rep(0,n)
    for(i in 1:n){
      ncumul_F0[i]<- sum(nF_0_2[ncumula(nx[i])])
    }
    
    ncumul_F1<-rep(0,n)
    for(i in 1:n){
      ncumul_F1[i]<- sum(nF_1_2[ncumula(nx[i])])
    }
    
    nA_2<-sum((1-ncumul_F1)*nF_0_2)
    nes_AUC<-nA_2/2+sum(ncumul_F0*nF_1_2)/2
    
    return(nes_AUC-eta[2])
  }
  
  
  h_beta<-uniroot(find_beta2,c(0,cbeta),tol=10^(-3))$root
  
  halpha<-function(theta)
  {
    
    A <- theta+h_beta*qx
    mz<-apply(cbind(rep(0,n),A),1,max)
    A_m<-A-mz
    B<-(1-rho)*exp(-mz)+rho*exp(A_m)
    l_1<- -sum( log(B)+mz)
    l_2 <- sum(A[(n_0+1):n])
    l<- -l_1-l_2
  }
  
  h_alpha<-optim(-0.5,halpha,method="L-BFGS-B")$par
  
  beta_case2<-list()
  beta_case2[[1]]<-1/n*1/(1-rho+rho*exp(h_alpha+h_beta*qx))
  beta_case2[[2]]<-1/n*1/((1-rho)*exp(-h_alpha-h_beta*qx)+rho)
  beta_case2[[3]]<-c(h_alpha,h_beta)
  
  return(beta_case2)
}


find_beta_j<-function(x0,x1,cbeta,eta,log_trans){
  nx<-c(x0,x1)
  n<-length(nx)
  n_0<-length(x0)
  n_1<-length(x1)
  rho<-length(x1)/n
  if(log_trans==T){
    qx<-log(c(x0,x1))
  }
  else{qx<-c(x0,x1)}
  find_beta<-function(t){
    
    nalpha<-function(theta)
    {
      
      A <- theta+t*qx
      mz<-apply(cbind(rep(0,n),A),1,max)
      A_m<-A-mz
      B<-(1-rho)*exp(-mz)+rho*exp(A_m)
      l_1<- -sum( log(B)+mz)
      l_2 <- sum(A[(n_0+1):n])
      l<- -l_1-l_2
    }
    nre <- optim(0.5,nalpha,method="L-BFGS-B")
    h_alpha<-nre$par
    
    if(log_trans==T){
      nhat_c<-exp(-h_alpha/t)}
    else{
      nhat_c<--h_alpha/t}
    
    nF_0_2<-1/n*1/(1-rho+rho*exp(h_alpha+t*qx))
    nF_1_2<-1/n*1/((1-rho)*exp(-h_alpha-t*qx)+rho)
    
    ncumula<-function(x){
      index_x<-which(x>=nx)
      index_x
    }
    
    ncumul_F0<-rep(0,n)
    for(i in 1:n){
      ncumul_F0[i]<- sum(nF_0_2[ncumula(nx[i])])
    }
    
    ncumul_F1<-rep(0,n)
    for(i in 1:n){
      ncumul_F1[i]<- sum(nF_1_2[ncumula(nx[i])])
    }
    
    
    nes_J<-function(x){
      sum(nF_0_2[ncumula(x)])-sum(nF_1_2[ncumula(x)])
    }
    
    if(nhat_c>=min(nx) && nhat_c<=max(nx) && nes_J( nhat_c)>=0 && nes_J(nhat_c)<=1 ){
      nes_hat_J<-nes_J(nhat_c); nhat_c_fina<-nhat_c
    }else{
      nesJ<-rep(0,n)
      nesJ<-ncumul_F0-ncumul_F1
      nes_hat_J<-max(nesJ)   ; nhat_c_fina<-nx[which.max(nesJ)]
    }
    
    return(nes_hat_J-eta[1])
  }
  
  
  h_beta<-uniroot(find_beta,c(0,cbeta),tol=10^(-3))$root
  
  halpha<-function(theta)
  {
    
    A <- theta+h_beta*qx
    mz<-apply(cbind(rep(0,n),A),1,max)
    A_m<-A-mz
    B<-(1-rho)*exp(-mz)+rho*exp(A_m)
    l_1<- -sum( log(B)+mz)
    l_2 <- sum(A[(n_0+1):n])
    l<- -l_1-l_2
  }
  
  h_alpha<-optim(-0.5,halpha,method="L-BFGS-B")$par
  
  beta_case3<-list()
  beta_case3[[1]]<-1/n*1/(1-rho+rho*exp(h_alpha+h_beta*qx))
  beta_case3[[2]]<-1/n*1/((1-rho)*exp(-h_alpha-h_beta*qx)+rho)
  beta_case3[[3]]<-c(h_alpha,h_beta)
  
  
  return(beta_case3)
}

sub_belt<-function(x1,x2,eta,log_trans){
  
  nx <- c(x1,x2)
  n<-length(nx)
  n_0<-length(x1)
  n_1<-length(x2)
  rho<-length(x2)/n
  if(log_trans==T){
    qx<-log(c(x1,x2))
  }
  else{qx<-c(x1,x2)}
  nFunc_theta<-function(theta)
  {
    
    A <- theta[1]+theta[2]*qx
    mz<-apply(cbind(rep(0,n),A),1,max)
    A_m<-A-mz
    B<-(1-rho)*exp(-mz)+rho*exp(A_m)
    l_1<- -sum( log(B)+mz)
    l_2 <- sum(A[(n_0+1):n])
    l<- -l_1-l_2
  }
  old_theta<-c(0.5,0.5)
  nre <- optim(old_theta,nFunc_theta,method="L-BFGS-B")
  nhat_theta<-nre$par
  
  
  if(log_trans==T){
    nhat_c<-exp(-nre$par[1]/nre$par[2])}
  else{
    nhat_c<--nre$par[1]/nre$par[2]}
  ## estimation of J ##
  nF_0_2<-1/n*1/(1-rho+rho*exp(nhat_theta[1]+nhat_theta[2]*qx))
  nF_1_2<-1/n*1/((1-rho)*exp(-nhat_theta[1]-nhat_theta[2]*qx)+rho)
  
  ncumula<-function(x){
    index_x<-which(x>=nx)
    index_x
  }
  
  
  
  ncumul_F0<-rep(0,n)
  for(i in 1:n){
    ncumul_F0[i]<- sum(nF_0_2[ncumula(nx[i])])
  }
  
  ncumul_F1<-rep(0,n)
  for(i in 1:n){
    ncumul_F1[i]<- sum(nF_1_2[ncumula(nx[i])])
  }
  
  ncu_F_0<-function(x){
    le<-length(x)
    cu_F0<-rep(0,le)
    for(i in 1:le){
      cu_F0[i]<- sum(nF_0_2[ncumula(x[i])])
    }
    cu_F0
  }
  
  ncu_F_1<-function(x){
    le<-length(x)
    cu_F1<-rep(0,le)
    for(i in 1:le){
      cu_F1[i]<- sum(nF_1_2[ncumula(x[i])])
    }
    cu_F1
  }
  
  
  nes_J<-function(x){
    sum(nF_0_2[ncumula(x)])-sum(nF_1_2[ncumula(x)])
  }
  
  
  if(nhat_c>=min(nx) && nhat_c<=max(nx) && nes_J( nhat_c)>=0 && nes_J(nhat_c)<=1 ){
    nes_hat_J<-nes_J(nhat_c); nhat_c_fina<-nhat_c
  }else{
    nesJ<-rep(0,n)
    nesJ<-ncumul_F0-ncumul_F1
    nes_hat_J<-max(nesJ)   ; nhat_c_fina<-nx[which.max(nesJ)]
  }
  
  
  nA_2<-sum((1-ncumul_F1)*nF_0_2)
  nes_AUC<-nA_2/2+sum(ncumul_F0*nF_1_2)/2
  
  
  S<-rho/(1-rho)*exp(nhat_theta[1]+nhat_theta[2]*qx)
  Q<-cbind(rep(1,n),qx)
  C<-matrix(rep(0,2*n),ncol=2)
  D<-matrix(rep(0,2*n),ncol=2)
  M<-matrix(rep(0,2*2),ncol=2)
  
  sig_00<-sum(nF_0_2*(1-(1-rho)/rho*S)^2/(S+1)*(nx<=nhat_c_fina))
  sig_01<-sum(nF_0_2*(1-(1-rho)/rho*S)*((1-rho)/rho*ncumul_F0*S+1-ncumul_F1)/(S+1)*(nx<=nhat_c_fina))
  sig_11<-sum(nF_0_2*((1-rho)/rho*ncumul_F0*S+1-ncumul_F1)^2/(S+1))
  C<-nF_0_2*(((1-rho)/rho*ncumul_F0-1+ncumul_F1)*S/(S+1))*Q
  D<-nF_0_2*((nx<=nhat_c_fina)*S/(S+1))*Q
  M<-t(Q)%*%((nF_0_2*(1-rho)*S/(S+1))*Q)
  
  hat_C<-apply(C,2,sum)
  hat_D<-apply(D,2,sum)
  hat_M<-solve(M)
  
  
  nSigma_00<- -1/(1-rho)*(ncu_F_0(nhat_c_fina))^2-1/rho*(ncu_F_1(nhat_c_fina))^2+1/(1-rho)*sig_00+1/(rho^2)*hat_D%*%hat_M%*%hat_D
  nSigma_01 <- -1/rho*hat_D%*%hat_M%*%hat_C-1/(1-rho)*ncu_F_0(nhat_c_fina)*(nA_2)+1/rho*(2*nes_AUC-(nA_2))*ncu_F_1(nhat_c_fina)+1/(1-rho)*sig_01
  nSigma_11 <- hat_C%*%hat_M%*%hat_C-1/(1-rho)*(nA_2)^2-1/rho*(2*nes_AUC-nA_2)^2+1/(1-rho)*sig_11
  
  
  req<-list()
  
  req[[1]]<-c(nes_hat_J,nes_AUC,nSigma_00/n,nSigma_11/n,min((nes_hat_J-eta[1])/sqrt(nSigma_00/n)*((nes_hat_J-eta[1])/sqrt(nSigma_00/n)>0),(nes_AUC-eta[2])/sqrt(nSigma_11/n)*((nes_AUC-eta[2])/sqrt(nSigma_11/n)>0)),nSigma_11/n)
  req[[2]]<-nF_0_2
  req[[3]]<-nF_1_2
  req[[4]]<-nhat_theta
  return(req)
  
  
}



BEL<-function(X,Y,nominal_level=0.95,log_trans=T,B=500){
  x = c(X,Y)
  n_0<-length(X)
  n_1<-length(Y)
  n<-n_0+n_1
  rho<-n_1/n
  
  T0<-sub_bel(X,Y,c(0,0.5),log_trans) 
  es_hat_J<-T0[[1]][1]
  es_AUC<-T0[[1]][2]
  
  # bootstrap
  qnes<-rep(0,B)
  iu<-1
  while (iu <=B){
    n_X_0<-sample(X,n_0,replace=TRUE)
    n_X_1<-sample(Y,n_1,replace=TRUE)
    
    if(max(n_X_0)<min(n_X_1)){iu=iu-1;next}
    #nX <- c(n_X_0,n_X_1)
    
    Tn<-sub_bel(n_X_0,n_X_1,c(es_hat_J,es_AUC),log_trans) 
    
    if(Tn[[1]][1]==-2 ){iu<-iu-1;next}
    
    
    qnes[iu]<-Tn[[1]][3]
    iu<-iu+1
  }
  iu<-iu-1
  if(length(which(is.na(qnes)))>=1){qnes<-qnes[-which(is.na(qnes))]}
  
  qnchi<-quantile(qnes,nominal_level)
  hat_Sig<-T0[[4]]
  
  
  ACR<-sqrt(det(hat_Sig))*3.141593*qnchi
  
  
  result<-list(estimated_J=es_hat_J,estimated_AUC=es_AUC, ACR=ACR, hat_Sigma=n*hat_Sig,theoretical_critical_value=qchisq(nominal_level,2),bootstrap_critical_value=qnchi)
  return(result)
}


BELT<-function(X,Y,AUC_0,J_0,log_trans=T,L=500){
  
  eta<-c(J_0,AUC_0) # H_0: AUC <= AUC_0 or J<=J_0
  n_0<-length(X)
  n_1<-length(Y)
  T0<-sub_belt(X,Y,eta,log_trans) # summary estimators and statistics # log(X) with qc=5 : Maintain the same form with the result that pass the goodness of fit test
  es_hat_J<- T0[[1]][1]
  es_AUC<-T0[[1]][2]
  x = c(X,Y)
  # bootstrap
  jacase<-rep(0,L)
  iu<-1
  
  if(es_hat_J>eta[1] && es_AUC > eta[2]){
    
    if((es_hat_J-eta[1])/sqrt(T0[[1]][3])>=(es_AUC - eta[2])/sqrt(T0[[1]][4])){
      
      cu_F_case2<-find_beta_auc(x0,x1,T0[[4]][2],eta,log_trans) # log(X) : Maintain the same form with the result that pass the goodness of fit test
      
      while (iu <=L){
        
        n_X_0<-sample(x,n_0,replace=T, prob=cu_F_case2[[1]])
        n_X_1<-sample(x,n_1,replace=T, prob=cu_F_case2[[2]])
        
        nX<-c(n_X_0,n_X_1)
        
        case2<-sub_belt(n_X_0,n_X_1,eta,log_trans) # log(nX) with qc=5 : Maintain the same form with the result that pass the goodness of fit test
        jacase[iu]<-case2[[1]][5]
        iu<-iu+1
      }
      iu<-iu-1
      
      
    }else{
      
      cu_F_case3<-find_beta_j(X,Y,T0[[4]][2],eta,log_trans) # log(X) with qc=5 : Maintain the same form with the result that pass the goodness of fit test
      
      while (iu <=L){
        
        n_X_0<-sample(x,n_0,replace=T, prob=cu_F_case3[[1]])
        n_X_1<-sample(x,n_1,replace=T, prob=cu_F_case3[[2]])
        
        nX<-c(n_X_0,n_X_1)
        case3<-sub_belt(n_X_0,n_X_1,eta,log_trans) # log(nX) with qc=5 : Maintain the same form with the result that pass the goodness of fit test
        
        jacase[iu]<-case3[[1]][5]
        
        iu<-iu+1
      }
      iu<-iu-1
      
    }
    
    p_value<- length(which(jacase>T0[[1]][5]))/L
    
  }
  
  if(es_hat_J<=eta[1] || es_AUC <= eta[2]){
    p_value<-1
  }
  
  # compare with alpha, if smaller, reject H_0
  
  return(list(p_value=p_value))
  
}

